
package de.bsvrz.sys.startstopp.api.jsonschema;

import java.io.Serializable;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;

@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonPropertyOrder({
    "aenderungsGrund",
    "erstelltAm",
    "erstelltDurch",
    "versionsNummer",
    "name"
})
public class MetaDaten implements Serializable
{

    @JsonProperty("aenderungsGrund")
    private String aenderungsGrund;
    @JsonProperty("erstelltAm")
    private String erstelltAm;
    @JsonProperty("erstelltDurch")
    private String erstelltDurch;
    @JsonProperty("versionsNummer")
    private String versionsNummer;
    @JsonProperty("name")
    private String name;
    private final static long serialVersionUID = 8135096473288460439L;

    /**
     * No args constructor for use in serialization
     * 
     */
    public MetaDaten() {
    }

    /**
     * 
     * @param erstelltAm
     * @param versionsNummer
     * @param name
     * @param aenderungsGrund
     * @param erstelltDurch
     */
    public MetaDaten(String aenderungsGrund, String erstelltAm, String erstelltDurch, String versionsNummer, String name) {
        super();
        this.aenderungsGrund = aenderungsGrund;
        this.erstelltAm = erstelltAm;
        this.erstelltDurch = erstelltDurch;
        this.versionsNummer = versionsNummer;
        this.name = name;
    }

    @JsonProperty("aenderungsGrund")
    public String getAenderungsGrund() {
        return aenderungsGrund;
    }

    @JsonProperty("aenderungsGrund")
    public void setAenderungsGrund(String aenderungsGrund) {
        this.aenderungsGrund = aenderungsGrund;
    }

    public MetaDaten withAenderungsGrund(String aenderungsGrund) {
        this.aenderungsGrund = aenderungsGrund;
        return this;
    }

    @JsonProperty("erstelltAm")
    public String getErstelltAm() {
        return erstelltAm;
    }

    @JsonProperty("erstelltAm")
    public void setErstelltAm(String erstelltAm) {
        this.erstelltAm = erstelltAm;
    }

    public MetaDaten withErstelltAm(String erstelltAm) {
        this.erstelltAm = erstelltAm;
        return this;
    }

    @JsonProperty("erstelltDurch")
    public String getErstelltDurch() {
        return erstelltDurch;
    }

    @JsonProperty("erstelltDurch")
    public void setErstelltDurch(String erstelltDurch) {
        this.erstelltDurch = erstelltDurch;
    }

    public MetaDaten withErstelltDurch(String erstelltDurch) {
        this.erstelltDurch = erstelltDurch;
        return this;
    }

    @JsonProperty("versionsNummer")
    public String getVersionsNummer() {
        return versionsNummer;
    }

    @JsonProperty("versionsNummer")
    public void setVersionsNummer(String versionsNummer) {
        this.versionsNummer = versionsNummer;
    }

    public MetaDaten withVersionsNummer(String versionsNummer) {
        this.versionsNummer = versionsNummer;
        return this;
    }

    @JsonProperty("name")
    public String getName() {
        return name;
    }

    @JsonProperty("name")
    public void setName(String name) {
        this.name = name;
    }

    public MetaDaten withName(String name) {
        this.name = name;
        return this;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(MetaDaten.class.getName()).append('@').append(Integer.toHexString(System.identityHashCode(this))).append('[');
        sb.append("aenderungsGrund");
        sb.append('=');
        sb.append(((this.aenderungsGrund == null)?"<null>":this.aenderungsGrund));
        sb.append(',');
        sb.append("erstelltAm");
        sb.append('=');
        sb.append(((this.erstelltAm == null)?"<null>":this.erstelltAm));
        sb.append(',');
        sb.append("erstelltDurch");
        sb.append('=');
        sb.append(((this.erstelltDurch == null)?"<null>":this.erstelltDurch));
        sb.append(',');
        sb.append("versionsNummer");
        sb.append('=');
        sb.append(((this.versionsNummer == null)?"<null>":this.versionsNummer));
        sb.append(',');
        sb.append("name");
        sb.append('=');
        sb.append(((this.name == null)?"<null>":this.name));
        sb.append(',');
        if (sb.charAt((sb.length()- 1)) == ',') {
            sb.setCharAt((sb.length()- 1), ']');
        } else {
            sb.append(']');
        }
        return sb.toString();
    }

    @Override
    public int hashCode() {
        int result = 1;
        result = ((result* 31)+((this.name == null)? 0 :this.name.hashCode()));
        result = ((result* 31)+((this.erstelltAm == null)? 0 :this.erstelltAm.hashCode()));
        result = ((result* 31)+((this.versionsNummer == null)? 0 :this.versionsNummer.hashCode()));
        result = ((result* 31)+((this.aenderungsGrund == null)? 0 :this.aenderungsGrund.hashCode()));
        result = ((result* 31)+((this.erstelltDurch == null)? 0 :this.erstelltDurch.hashCode()));
        return result;
    }

    @Override
    public boolean equals(Object other) {
        if (other == this) {
            return true;
        }
        if ((other instanceof MetaDaten) == false) {
            return false;
        }
        MetaDaten rhs = ((MetaDaten) other);
        return ((((((this.name == rhs.name)||((this.name!= null)&&this.name.equals(rhs.name)))&&((this.erstelltAm == rhs.erstelltAm)||((this.erstelltAm!= null)&&this.erstelltAm.equals(rhs.erstelltAm))))&&((this.versionsNummer == rhs.versionsNummer)||((this.versionsNummer!= null)&&this.versionsNummer.equals(rhs.versionsNummer))))&&((this.aenderungsGrund == rhs.aenderungsGrund)||((this.aenderungsGrund!= null)&&this.aenderungsGrund.equals(rhs.aenderungsGrund))))&&((this.erstelltDurch == rhs.erstelltDurch)||((this.erstelltDurch!= null)&&this.erstelltDurch.equals(rhs.erstelltDurch))));
    }

}
