
package de.bsvrz.sys.startstopp.api.jsonschema;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import com.fasterxml.jackson.annotation.JsonAnyGetter;
import com.fasterxml.jackson.annotation.JsonAnySetter;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;

@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonPropertyOrder({
    "global",
    "inkarnationen",
    "metaDaten"
})
public class StartStoppSkript implements Serializable
{

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("global")
    private Global global;
    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("inkarnationen")
    private List<Inkarnation> inkarnationen = new ArrayList<Inkarnation>();
    @JsonProperty("metaDaten")
    private MetaDaten metaDaten;
    @JsonIgnore
    private Map<String, Object> additionalProperties = new HashMap<String, Object>();
    private final static long serialVersionUID = 8719286284944672525L;

    /**
     * No args constructor for use in serialization
     * 
     */
    public StartStoppSkript() {
    }

    /**
     * 
     * @param inkarnationen
     * @param metaDaten
     * @param global
     */
    public StartStoppSkript(Global global, List<Inkarnation> inkarnationen, MetaDaten metaDaten) {
        super();
        this.global = global;
        this.inkarnationen = inkarnationen;
        this.metaDaten = metaDaten;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("global")
    public Global getGlobal() {
        return global;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("global")
    public void setGlobal(Global global) {
        this.global = global;
    }

    public StartStoppSkript withGlobal(Global global) {
        this.global = global;
        return this;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("inkarnationen")
    public List<Inkarnation> getInkarnationen() {
        return inkarnationen;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("inkarnationen")
    public void setInkarnationen(List<Inkarnation> inkarnationen) {
        this.inkarnationen = inkarnationen;
    }

    public StartStoppSkript withInkarnationen(List<Inkarnation> inkarnationen) {
        this.inkarnationen = inkarnationen;
        return this;
    }

    @JsonProperty("metaDaten")
    public MetaDaten getMetaDaten() {
        return metaDaten;
    }

    @JsonProperty("metaDaten")
    public void setMetaDaten(MetaDaten metaDaten) {
        this.metaDaten = metaDaten;
    }

    public StartStoppSkript withMetaDaten(MetaDaten metaDaten) {
        this.metaDaten = metaDaten;
        return this;
    }

    @JsonAnyGetter
    public Map<String, Object> getAdditionalProperties() {
        return this.additionalProperties;
    }

    @JsonAnySetter
    public void setAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
    }

    public StartStoppSkript withAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
        return this;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(StartStoppSkript.class.getName()).append('@').append(Integer.toHexString(System.identityHashCode(this))).append('[');
        sb.append("global");
        sb.append('=');
        sb.append(((this.global == null)?"<null>":this.global));
        sb.append(',');
        sb.append("inkarnationen");
        sb.append('=');
        sb.append(((this.inkarnationen == null)?"<null>":this.inkarnationen));
        sb.append(',');
        sb.append("metaDaten");
        sb.append('=');
        sb.append(((this.metaDaten == null)?"<null>":this.metaDaten));
        sb.append(',');
        sb.append("additionalProperties");
        sb.append('=');
        sb.append(((this.additionalProperties == null)?"<null>":this.additionalProperties));
        sb.append(',');
        if (sb.charAt((sb.length()- 1)) == ',') {
            sb.setCharAt((sb.length()- 1), ']');
        } else {
            sb.append(']');
        }
        return sb.toString();
    }

    @Override
    public int hashCode() {
        int result = 1;
        result = ((result* 31)+((this.global == null)? 0 :this.global.hashCode()));
        result = ((result* 31)+((this.additionalProperties == null)? 0 :this.additionalProperties.hashCode()));
        result = ((result* 31)+((this.inkarnationen == null)? 0 :this.inkarnationen.hashCode()));
        result = ((result* 31)+((this.metaDaten == null)? 0 :this.metaDaten.hashCode()));
        return result;
    }

    @Override
    public boolean equals(Object other) {
        if (other == this) {
            return true;
        }
        if ((other instanceof StartStoppSkript) == false) {
            return false;
        }
        StartStoppSkript rhs = ((StartStoppSkript) other);
        return (((((this.global == rhs.global)||((this.global!= null)&&this.global.equals(rhs.global)))&&((this.additionalProperties == rhs.additionalProperties)||((this.additionalProperties!= null)&&this.additionalProperties.equals(rhs.additionalProperties))))&&((this.inkarnationen == rhs.inkarnationen)||((this.inkarnationen!= null)&&this.inkarnationen.equals(rhs.inkarnationen))))&&((this.metaDaten == rhs.metaDaten)||((this.metaDaten!= null)&&this.metaDaten.equals(rhs.metaDaten))));
    }

}
