
package de.bsvrz.sys.startstopp.api.jsonschema;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;
import com.fasterxml.jackson.annotation.JsonAnyGetter;
import com.fasterxml.jackson.annotation.JsonAnySetter;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;

@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonPropertyOrder({
    "name",
    "version",
    "erstelltDurch",
    "aenderungsGrund",
    "pruefsumme"
})
public class StartStoppVersion implements Serializable
{

    @JsonProperty("name")
    private String name;
    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("version")
    private String version;
    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("erstelltDurch")
    private String erstelltDurch;
    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("aenderungsGrund")
    private String aenderungsGrund;
    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("pruefsumme")
    private String pruefsumme;
    @JsonIgnore
    private Map<String, Object> additionalProperties = new HashMap<String, Object>();
    private final static long serialVersionUID = -3322589056044177778L;

    /**
     * No args constructor for use in serialization
     * 
     */
    public StartStoppVersion() {
    }

    /**
     * 
     * @param name
     * @param pruefsumme
     * @param version
     * @param aenderungsGrund
     * @param erstelltDurch
     */
    public StartStoppVersion(String name, String version, String erstelltDurch, String aenderungsGrund, String pruefsumme) {
        super();
        this.name = name;
        this.version = version;
        this.erstelltDurch = erstelltDurch;
        this.aenderungsGrund = aenderungsGrund;
        this.pruefsumme = pruefsumme;
    }

    @JsonProperty("name")
    public String getName() {
        return name;
    }

    @JsonProperty("name")
    public void setName(String name) {
        this.name = name;
    }

    public StartStoppVersion withName(String name) {
        this.name = name;
        return this;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("version")
    public String getVersion() {
        return version;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("version")
    public void setVersion(String version) {
        this.version = version;
    }

    public StartStoppVersion withVersion(String version) {
        this.version = version;
        return this;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("erstelltDurch")
    public String getErstelltDurch() {
        return erstelltDurch;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("erstelltDurch")
    public void setErstelltDurch(String erstelltDurch) {
        this.erstelltDurch = erstelltDurch;
    }

    public StartStoppVersion withErstelltDurch(String erstelltDurch) {
        this.erstelltDurch = erstelltDurch;
        return this;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("aenderungsGrund")
    public String getAenderungsGrund() {
        return aenderungsGrund;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("aenderungsGrund")
    public void setAenderungsGrund(String aenderungsGrund) {
        this.aenderungsGrund = aenderungsGrund;
    }

    public StartStoppVersion withAenderungsGrund(String aenderungsGrund) {
        this.aenderungsGrund = aenderungsGrund;
        return this;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("pruefsumme")
    public String getPruefsumme() {
        return pruefsumme;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("pruefsumme")
    public void setPruefsumme(String pruefsumme) {
        this.pruefsumme = pruefsumme;
    }

    public StartStoppVersion withPruefsumme(String pruefsumme) {
        this.pruefsumme = pruefsumme;
        return this;
    }

    @JsonAnyGetter
    public Map<String, Object> getAdditionalProperties() {
        return this.additionalProperties;
    }

    @JsonAnySetter
    public void setAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
    }

    public StartStoppVersion withAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
        return this;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(StartStoppVersion.class.getName()).append('@').append(Integer.toHexString(System.identityHashCode(this))).append('[');
        sb.append("name");
        sb.append('=');
        sb.append(((this.name == null)?"<null>":this.name));
        sb.append(',');
        sb.append("version");
        sb.append('=');
        sb.append(((this.version == null)?"<null>":this.version));
        sb.append(',');
        sb.append("erstelltDurch");
        sb.append('=');
        sb.append(((this.erstelltDurch == null)?"<null>":this.erstelltDurch));
        sb.append(',');
        sb.append("aenderungsGrund");
        sb.append('=');
        sb.append(((this.aenderungsGrund == null)?"<null>":this.aenderungsGrund));
        sb.append(',');
        sb.append("pruefsumme");
        sb.append('=');
        sb.append(((this.pruefsumme == null)?"<null>":this.pruefsumme));
        sb.append(',');
        sb.append("additionalProperties");
        sb.append('=');
        sb.append(((this.additionalProperties == null)?"<null>":this.additionalProperties));
        sb.append(',');
        if (sb.charAt((sb.length()- 1)) == ',') {
            sb.setCharAt((sb.length()- 1), ']');
        } else {
            sb.append(']');
        }
        return sb.toString();
    }

    @Override
    public int hashCode() {
        int result = 1;
        result = ((result* 31)+((this.name == null)? 0 :this.name.hashCode()));
        result = ((result* 31)+((this.additionalProperties == null)? 0 :this.additionalProperties.hashCode()));
        result = ((result* 31)+((this.pruefsumme == null)? 0 :this.pruefsumme.hashCode()));
        result = ((result* 31)+((this.version == null)? 0 :this.version.hashCode()));
        result = ((result* 31)+((this.aenderungsGrund == null)? 0 :this.aenderungsGrund.hashCode()));
        result = ((result* 31)+((this.erstelltDurch == null)? 0 :this.erstelltDurch.hashCode()));
        return result;
    }

    @Override
    public boolean equals(Object other) {
        if (other == this) {
            return true;
        }
        if ((other instanceof StartStoppVersion) == false) {
            return false;
        }
        StartStoppVersion rhs = ((StartStoppVersion) other);
        return (((((((this.name == rhs.name)||((this.name!= null)&&this.name.equals(rhs.name)))&&((this.additionalProperties == rhs.additionalProperties)||((this.additionalProperties!= null)&&this.additionalProperties.equals(rhs.additionalProperties))))&&((this.pruefsumme == rhs.pruefsumme)||((this.pruefsumme!= null)&&this.pruefsumme.equals(rhs.pruefsumme))))&&((this.version == rhs.version)||((this.version!= null)&&this.version.equals(rhs.version))))&&((this.aenderungsGrund == rhs.aenderungsGrund)||((this.aenderungsGrund!= null)&&this.aenderungsGrund.equals(rhs.aenderungsGrund))))&&((this.erstelltDurch == rhs.erstelltDurch)||((this.erstelltDurch!= null)&&this.erstelltDurch.equals(rhs.erstelltDurch))));
    }

}
